Name:		hp-i40evf
Version:	3.5.13
Release:	0.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	HP Intel i40evf Ethernet Kernel Module

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
This package provides the HP Intel i40evf Ethernet Kernel Module.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HP Intel i40evf Ethernet Kernel Module
Group: System/Kernel

%description KMP
This package provides the HP Intel i40evf Ethernet Kernel Module.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HP Intel i40evf Ethernet Kernel Module

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override i40evf * weak-updates/%{name}" > %{name}.conf

%build
find ./ -name *.c -print0 | xargs -0 sed -i '/MODULE_LICENSE(/a MODULE_INFO(retpoline, "Y");'
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/i40evf.7 > source/i40evf.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} rpm

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/i40evf.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/i40evf.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/i40evf.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/i40evf.7.gz
%doc source/COPYING source/README

%changelog
* Wed Aug 08 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- This driver fixes the issue of VIRTCHNL_OP_ENABLE_QUEUES handler does not used rx_queues/tx_queues correctly.
- Added RHEL6u10 Support.
- Added RHEL7u5 Support.

* Thu Jul 26 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.5.6.1-8
- This driver fixes the issue of Spectre/Meltdown.
- This driver fixes the issue of submodules adding.
- This driver fixes the issue of the note about Linux SR-IOV guest OS not supported on Windows Hyper-V host.
- Added SLES15 support.

* Tue Oct 31 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.3.6-1
- This driver now alllows to use ethtool -m on DAC with or without NPAR
- This driver now alllows to pass traffic from bond/VF in RHEL 7.3 guest using IovQueuePairsRequested setting above 1 with "MCP" XXV710-2 on WS 2016
- This driver fixes the supported autoneg for devices with CRT_RETIMER
- This driver now ignores locality when spreading vectors over CPUs
- This driver now allows to change VLAN Tag Stripping
- This driver now allows to set MTU value to more than 1500 in SLES12SP3 with Intel NICs
- This driver fixes the issue of enabling support for VF VLAN tag stripping control
- This driver fixes the issue of mac filter removal timing issue
- This driver fixes the issue of ethtool not showing up dual-speed modules advertisements
- This driver fixes the issue of supported link modes/PHY types does not report correctly
- This driver now supports Ethtool -m command on QSFP+ SR optical module
- This driver fixes the issue of FVL-6 MCP-25G Fails to Survive RSS Queue Resize During Stress Test
- This driver now does not miss dual-speed advertisements on 25G ethtool link_ksettings
- This driver now fixes the issue of "ethtool -p" cause traffic to be interrupted and all port LED to blink
- This driver addresses an issue with branding string in RHEL7.4
- This driver now fix the issue of LIS prevents switching back to the VF path in RHEL 7.3 guest
- This driver addresses the Kernel panic on SLES12SP2  when changing Jumbo Frames on the PF
- This driver fixes the issue of could not change device features with Adapter Type SR-IOV passthrough and VSwitch VLAN Tagging Mode.
- This driver fixes the issue of Flow Director Sideband rules do not update quite as expected.
- This driver fixes the issue of VxLAN checksum offload counter increments without VxLAN tunnels present.
- This driver fixes the issue of memory leak related to filter programming status.
- Feature implemention for split PCI error reset handler
- Feature implementation to return an error message when module that does not meet thermal requirements is plugged.
- ture implementation to add wrap recovery mode.
- Feature implementation to add ethtool_intersect_link_masks
- Feature implementation to add some hw_csum rx offload counters

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.0.28-3
- Added support for HPE Ethernet 1Gb 2-port 368i Adapter
- Added support for HPE Ethernet 1Gb 4-port 369i Adapter
- Added support for HPE Ethernet 1Gb 2-port 368FLR-MMT Adapter
- Added support for HPE Ethernet 10Gb 2-port 568FLR-MMT Adapter
- Added support for HPE Ethernet 10Gb 2-port 568FLR-MMSFP+ Adapter
- Added SLES12SP3 support
- Added RHEL7.4 support

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.0.16-2[rhel6u9], 2.0.16-1[For other OSs]
- Added support for HPE Ethernet 10Gb 2-port 568i Adapter
- Added SLES12SP2 support
- Added RHEL7.3 support
- Feature implementation for speading out interrupts and to use all rx queues and all cpus
- Fix for NVM update process hangs on Linux at 88%

* Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.3.33.3-1.rhel6u8
- Added RHEL 6.8 support

* Mon Nov 30 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.3.33.2-7
 - Added support for SLES12SP1
 - Added support for RHEL 7.2
 - This driver addresses an issue where Virtual Function (VF) VLAN stops working if the device Physical Function (PF) is changed to Promiscuous Mode.

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.2.34-4
 - Added support for SLES11SP4
 - Added support for RHEL 6.7

* Tue Apr 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.2.33-1
  - Initial release of i40evf driver to support Intel(R) 40 Gigabit Adapters based virtual function devices that can only be activated on kernels that support SR-IOV.

